
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
<h1>Templating</h1>
<p>В прошлом упражнении мы создавали HTML разметку как строку. Конечно, никто не запрещает создавать HTML напрямую в виде строки, но такой способ просто перестает работать на реальных сайтах, где HTML одной страницы — это сотни, а то и тысячи строк. Для решения этой проблемы существует технология JSP.</p>
<p>JSP — это технология, позволяющая разработчикам создавать содержимое, которое имеет как статические, так и динамические компоненты. Страница JSP содержит текст двух типов: статические исходные данные, оформленные в формате HTML, и JSP-элементы, которые конструируют динамическое содержимое. В этом упражнении вам предстоит создать такие JSP — страницы.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://getbootstrap.com/docs/5.1/getting-started/introduction/#css">Подключение стилей Bootstrap</a></li>
<li data-marpit-fragment="2"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpServletResponse.html">Документация по HttpServletResponse</a></li>
<li data-marpit-fragment="3"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpServletRequest.html">Документация HttpServletRequest</a></li>
<li data-marpit-fragment="4"><a href="https://ru.wikipedia.org/wiki/JavaServer_Pages_Standard_Tag_Library">Стандартная библиотека тегов JSP</a></li>
<li data-marpit-fragment="5"><a href="https://docs.oracle.com/javaee/5/jstl/1.1/docs/tlddocs/c/tld-summary.html">Документация по JSTL</a></li>
<li data-marpit-fragment="6"><a href="https://www.baeldung.com/jstl">Пример работы с библиотекой JSTL</a></li>
<li data-marpit-fragment="7"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/ServletRequest.html#setAttribute-java.lang.String-java.lang.Object-">Метод setAttribute()</a></li>
<li data-marpit-fragment="8"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/RequestDispatcher.html">Request dispatcher</a></li>
<li data-marpit-fragment="9"><a href="https://developer.mozilla.org/ru/docs/Web/HTML/Element/form">Html тег &lt;form&gt;</a></li>
</ul>
<h2>App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="10">Зарегистрируйте в контейнере tomcat сервлет <code>UsersServlet</code>, так чтобы он обрабатывал запросы по пути <code>/users/*</code>. Для проверки работы приложения запустите сервер, используя команду <code>make start</code>. Приложение в браузере будет доступно по адресу <em><a href="http://localhost:5000">http://localhost:5000</a></em>.</li>
</ul>
<h2>servlet/UsersServlet.java</h2>
<p>В этом упражнении мы будем работать с данными, которые расположены в памяти. Список пользователей уже создан и записан в свойстве <code>users</code> класса <code>UsersServlet</code>. Структура списка такая же, как и в предыдущем упражнении:</p>
<pre><code class="language-java">  <span class="hljs-comment">// Гипотетический пример показывающий структуру</span>
  users = [
    {
      <span class="hljs-string">&quot;id&quot;</span>: <span class="hljs-string">&quot;4&quot;</span>,
      <span class="hljs-string">&quot;firstName&quot;</span>: <span class="hljs-string">&quot;John&quot;</span>,
      <span class="hljs-string">&quot;lastName&quot;</span>: <span class="hljs-string">&quot;Doe&quot;</span>,
      <span class="hljs-string">&quot;email&quot;</span>: <span class="hljs-string">&quot;johndoe@gmail.com&quot;</span>,
    },
    <span class="hljs-comment">// другие пользователи</span>
  ]
</code></pre>
<p>В упражнении добавляется ещё один маршрут и обработчик, которые реализуют удаление пользователя из памяти. Но кнопка удаления ни в коем случае не должна сразу удалять. Человеку свойственно ошибаться (а ещё он любопытен) и вероятность, что он нажмёт на эту кнопку по ошибке, крайне высока. Правильный подход состоит в том, чтобы вывести страницу с подтверждением и спросить у пользователя, уверен ли он в том, что хочет удалить. Если да, то только в этом случае удалять.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">
<p>Изучите содержимое метода <code>doGet()</code>, который в зависимости от пути в адресе запроса вызывает нужный обработчик (метод).</p>
</li>
<li data-marpit-fragment="12">
<p>В методе <code>showUsers()</code> реализуйте передачу управления в jsp-файл <em>/users.jsp</em>. Для того, чтобы предать данные пользователей в jsp-файл, вам потребуется установить атрибуты запроса при помощи метода <code>setAttribute()</code>.</p>
</li>
<li data-marpit-fragment="13">
<p>В методе <code>showUser()</code> реализуйте передачу управления в jsp-файл <em>/show.jsp</em>. id пользователя передается как параметр в query string<br />
Например, ссылка на страницу пользователя с id = 5, будет выглядеть так: <em>/users/show?id=5</em></p>
</li>
<li data-marpit-fragment="14">
<p>Метод <code>showDeletePage()</code> выводит страницу с подтверждением удаления. Организуйте передачу управления в в jsp-файл <em>/delete.jsp</em>. Вам понадобится передать в шаблон данные пользователя для вывода текста с подтверждением удаления.</p>
</li>
<li data-marpit-fragment="15">
<p>Изучите содержимое метода <code>doPost()</code>. Этот метод обрабатывает все запросы с глаголом POST, поступившие на адрес <em>/users/*</em>. В зависимости от пути в адресе запроса этот метод также вызывает нужный обработчик.</p>
</li>
<li data-marpit-fragment="16">
<p>В методе <code>deleteUser()</code> реализуйте удаление пользователя из памяти. После удаления нужно будет выполнить редирект на страницу вывода всех пользователей <em>/users</em>.</p>
</li>
</ul>
<h2>webapp/users.jsp</h2>
<p>Шаблон с выводом списка всех пользователей.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="17">Организуйте вывод списка всех пользователей. Удобнее всего для этого использовать таблицу. Каждый пользователь в списке должен быть ссылкой на собственную страницу пользователя.</li>
</ul>
<h2>webapp/show.jsp</h2>
<p>Шаблон с выводом данных определенного пользователя.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="18">Организуйте вывод данных одного определенного пользователя. Сделайте это, как вам удобно. На экран должны выводиться id, имя пользователя и его email. На странице пользователя должна быть ссылка для удаления текущего пользователя. Ссылка должна вести на страницу с подтверждением удаления, например <em>/users/delete?id=10</em>, где id пользователя, которого нужно удалить, передается как параметр в query string.</li>
</ul>
<h2>webapp/delete.jsp</h2>
<p>Шаблон с подтверждением удаления пользователя.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="19">Организуйте вывод страницы с подтверждением удаления пользователя. На странице должен быть текст, уточняющий, действительно ли вы хотите удалить этого пользователя. На странице разместите форму с кнопкой &quot;Удалить&quot;, подтверждающей удаление.</li>
</ul>
<p>Нажатие на кнопку &quot;Удалить&quot; должно отправить форму используя POST-запрос на адрес <em>/users/delete?id=...</em>, где параметр <code>id</code> — это id пользователя, которого мы хотим удалить. Напрмер, чтобы удалить пользователя с id = 5, нужно отправить POST запрос на адрес <em>/users/delete?id=5</em>.</p>
<p>Для того, чтобы отправить POST запрос, вам потребуется использовать форму.</p>
<pre><code class="language-html"><span class="hljs-tag">&lt;<span class="hljs-name">form</span> <span class="hljs-attr">action</span>=<span class="hljs-string">&quot;url&quot;</span> <span class="hljs-attr">method</span>=<span class="hljs-string">&quot;post&quot;</span>&gt;</span>
    <span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">type</span>=<span class="hljs-string">&quot;submit&quot;</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;btn btn-danger&quot;</span>&gt;</span>Удалить<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;/<span class="hljs-name">form</span>&gt;</span>
</code></pre>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="20">В jsp-файлах подключена библиотека тегов <code>jstl</code>, расширяющая возможности jsp, вы можете использовать её.</li>
<li data-marpit-fragment="21">Для передачи управления в jsp-файл вам понадобится использовать метод <code>forward()</code> класса <code>RequestDispatcher</code></li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  